package CH.psi.midas;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.beans.*;
import java.util.TooManyListenersException;

public class MJLabel extends javax.swing.JLabel implements OdbKeyUpdate,Serializable
{

  public MJLabel()
  {
    //{{INIT_CONTROLS
	setLayout(null);
	setSize(72,24);
	//}}
  }
  
  public MJLabel(String odbPath)
  {
    setOdbPath(odbPath);
  }

  //{{DECLARE_CONTROLS
  //}}

  public void setData(java.lang.String data) throws IOException
  {
    String oldValue = new String(this.data);
    String newValue = new String(data);
    this.data = data;
    
    // signal property change
    super.firePropertyChange("data" ,oldValue, newValue);
		
    // propagate change to ODBKey
    if (odbKey != null)
      odbKey.setText(data);
        
    // display new text and optionally format it
    if (formatter != null)
      setText(formatter.format(data, this));
    else
      setText(data);
  }

  public void reformat()
  {
    // display new text and optionally format it
    if (formatter != null)
      setText(formatter.format(data, this));
    else
      setText(data);
  }

  public java.lang.String getData()
  {
    return this.data;
  }

  public void setOdbPath(java.lang.String odbPath)
  {
    this.odbPath = odbPath;
  }

  public java.lang.String getOdbPath()
  {
    return this.odbPath;
  }

  public OdbKey getOdbKey()
  {
    return this.odbKey;
  }
  
  public void setAutoUpdate(boolean autoUpdate)
  {
    try {
      if (!this.autoUpdate && autoUpdate)
	    odbKey.hotLink(this);
            	      
      if (this.autoUpdate && !autoUpdate)
	    odbKey.hotUnlink();
	  } catch (Exception e) { System.out.println(e); }
            	      
    this.autoUpdate = autoUpdate;
  }

  public boolean isAutoUpdate()
  {
    return this.autoUpdate;
  }

  public void connect(Experiment exp) throws 
                IOException, TooManyListenersException, OdbKeyNotFoundException 
  {
    // create ODBKey and hot link
    odbKey = new OdbKey(exp, odbPath);
    if (autoUpdate)
      odbKey.hotLink(this);

    this.data = odbKey.toString();
    
    // display new text and optionally format it
    if (formatter != null)
      setText(formatter.format(data, this));
    else
      setText(data);
  }

  public void update(OdbKey key) 
  {
	String oldValue = new String(this.data);
	String newValue = new String(key.toString());
	this.data = key.toString();
	
    // signal property change
	super.firePropertyChange("data" ,oldValue, newValue);
		
    // display new text and optionally format it
    if (formatter != null)
      setText(formatter.format(data, this));
    else
      setText(data);
  }

  public void addFormatter(OdbKeyFormatter formatter) {
    this.formatter = formatter;
  }
  
  static public void main(String args[])
  {
    class DriverFrame extends java.awt.Frame {
	  public DriverFrame() {
	    addWindowListener(new java.awt.event.WindowAdapter() {
          public void windowClosing(java.awt.event.WindowEvent event)
		    {
			dispose();	  // free the system resources
			System.exit(0); // close the application
			}
		});
		
		this.setLayout(null);
		this.setSize(72,24);
		this.add(new MJLabel());
	  }
	}

    new DriverFrame().show();
  }

  // bean properties
  protected java.lang.String data = "";
  protected java.lang.String odbPath = "";
  protected boolean autoUpdate = true;

  // bean internal key
  protected OdbKey odbKey = null;

  // optional key formatter
  private OdbKeyFormatter formatter = null;

}