import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import CH.psi.midas.*;
import com.symantec.itools.javax.swing.icons.ImageIcon;

import bsh.*;

/**
 * MIDAS experiment control program
 */
public class JMidas extends javax.swing.JFrame implements OdbKeyUpdate
{
  // Member variables
  Experiment experiment = null;
  
  public JMidas()
	{
    // Set application Icon
    ImageIcon jmidasIcon = new ImageIcon(getClass().getResource("images/midas.gif"));
    setIconImage(jmidasIcon.getImage());
    
	//{{INIT_CONTROLS
	setJMenuBar(JMenuBar1);
	getContentPane().setLayout(new BorderLayout(0,0));
	setSize(500,450);
	setVisible(false);
	JPanel2.setLayout(new FlowLayout(FlowLayout.LEFT,0,0));
	getContentPane().add(BorderLayout.NORTH, JPanel2);
	JPanel2.setBounds(0,0,500,31);
	JToolBar1.setAlignmentY(0.222222F);
	JPanel2.add(JToolBar1);
	JToolBar1.setBounds(0,0,171,31);
	buttonStart.setDefaultCapable(false);
	buttonStart.setToolTipText("Start a run");
		buttonStart.setEnabled(false);
	JToolBar1.add(buttonStart);
	buttonStart.setBounds(16,2,51,27);
	buttonStop.setDefaultCapable(false);
	buttonStop.setToolTipText("Stop current run");
	JToolBar1.add(buttonStop);
	buttonStop.setBounds(67,2,51,27);
	buttonPause.setDefaultCapable(false);
	buttonPause.setToolTipText("Pause/Resume run");
	JToolBar1.add(buttonPause);
	buttonPause.setBounds(118,2,51,27);
	JToolBar1.addSeparator();
	JPanel1.setLayout(new BorderLayout(0,0));
	getContentPane().add(BorderLayout.CENTER, JPanel1);
	JPanel1.setBounds(0,31,500,419);
	JPanel1.add(BorderLayout.CENTER,JTabbedPane1);
	JTabbedPane1.setBounds(0,0,500,419);
	//## remove (bug in VisualCafe!) JPanelStatus1.setLayout(null);
	JTabbedPane1.add(JPanelStatus1);
	JPanelStatus1.setBounds(2,27,495,389);
	JPanelStatus1.setVisible(false);
	//## JPanelOdb1.setLayout(new BorderLayout(0,0));
	JTabbedPane1.add(JPanelOdb1);
	JPanelOdb1.setBounds(2,27,495,389);
	JPanelOdb1.setVisible(false);
	//## JPanelHistory1.setLayout(new BorderLayout(0,0));
	JTabbedPane1.add(JPanelHistory1);
	JPanelHistory1.setBounds(2,27,495,389);
		JPanelHistory1.setVisible(false);
	JPanelBsh.setLayout(new BorderLayout(0,0));
	JTabbedPane1.add(JPanelBsh);
	JPanelBsh.setBounds(2,27,495,389);
	JPanelBsh.setVisible(false);
	JTabbedPane1.setSelectedIndex(0);
	JTabbedPane1.setSelectedComponent(JPanelStatus1);
	JTabbedPane1.setTitleAt(0,"Status");
		JTabbedPane1.setTitleAt(1,"ODB");
		JTabbedPane1.setTitleAt(2,"History");
		JTabbedPane1.setTitleAt(3,"Script");
	//$$ JMenuBar1.move(240,432);
	fileMenu.setText("File");
	fileMenu.setActionCommand("File");
	fileMenu.setMnemonic((int)'F');
	JMenuBar1.add(fileMenu);
	startItem.setText("Start...");
		startItem.setActionCommand("Start...");
	startItem.setToolTipText("Start a new Run");
	startItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_S, java.awt.Event.CTRL_MASK));
	startItem.setMnemonic((int)'S');
	fileMenu.add(startItem);
	stopItem.setText("Stop");
		stopItem.setActionCommand("Stop");
	stopItem.setToolTipText("Stop current Run");
	stopItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_P, java.awt.Event.CTRL_MASK));
	stopItem.setMnemonic((int)'P');
	fileMenu.add(stopItem);
	pauseItem.setText("Pause");
		pauseItem.setActionCommand("Pause");
	pauseItem.setToolTipText("Pause/Resume Run");
	pauseItem.setMnemonic((int)'S');
	fileMenu.add(pauseItem);
	fileMenu.addSeparator();
	exitItem.setText("Exit...");
		exitItem.setActionCommand("Exit...");
	exitItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_X, java.awt.Event.CTRL_MASK));
	exitItem.setMnemonic((int)'X');
	fileMenu.add(exitItem);
	helpMenu.setText("Help");
		helpMenu.setActionCommand("Help");
	helpMenu.setMnemonic((int)'H');
	JMenuBar1.add(helpMenu);
	aboutItem.setText("About...");
		aboutItem.setActionCommand("About...");
	aboutItem.setMnemonic((int)'A');
	helpMenu.add(aboutItem);
		try {
			iconStart.setImageLocation(symantec.itools.net.RelativeURL.getURL("images/start.gif"));
		}
		catch (java.net.MalformedURLException error) { }
		//$$ iconStart.move(0,401);
		try {
			iconStop.setImageLocation(symantec.itools.net.RelativeURL.getURL("images/stop.gif"));
		}
		catch (java.net.MalformedURLException error) { }
		//$$ iconStop.move(24,401);
		try {
			iconPause.setImageLocation(symantec.itools.net.RelativeURL.getURL("images/pause.gif"));
		}
		catch (java.net.MalformedURLException error) { }
		//$$ iconPause.move(48,401);
		//$$ imageIcon1.move(48,401);
		buttonStop.setIcon(iconStop);
		buttonStart.setIcon(iconStart);
		buttonPause.setIcon(iconPause);
	//}}
	
	//{{INIT_MENUS
	//}}

	//{{REGISTER_LISTENERS
	SymWindow aSymWindow = new SymWindow();
	this.addWindowListener(aSymWindow);
	SymAction lSymAction = new SymAction();
	startItem.addActionListener(lSymAction);
	stopItem.addActionListener(lSymAction);
	pauseItem.addActionListener(lSymAction);
	exitItem.addActionListener(lSymAction);
	aboutItem.addActionListener(lSymAction);
	buttonStart.addActionListener(lSymAction);
	buttonStop.addActionListener(lSymAction);
	buttonPause.addActionListener(lSymAction);
	//}}
	}

    /**
     * Creates a new instance of JFrame1 with the given title.
     * @param sTitle the title for the new frame.
     * @see #JFrame1()
     */
	public JMidas(String sTitle)
	{
		this();
		setTitle(sTitle);
	}
	
	/**
	 * The entry point for this application.
	 * Sets the Look and Feel to the System Look and Feel.
	 * Creates a new JFrame1 and makes it visible.
	 */
	static public void main(String args[])
	{
		try {
		    // Add the following code if you want the Look and Feel
		    // to be set to the Look and Feel of the native system.
		    /*
		    try {
		        UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		    } 
		    catch (Exception e) { 
		    }
		    */

			//Create a new instance of our application's frame, and make it visible.
			JMidas jmidas = new JMidas("JMidas");

            // Create experiment and connect to it
            jmidas.createExperiment(args);

			jmidas.setVisible(true);
		} 
		catch (Throwable t) {
			t.printStackTrace();
			//Ensure the application exits with an error condition.
			System.exit(1);
		}
	}

    private void createExperiment(String args[])
    {
      int i;
      String host = "", exp = "";
      
      // evaluate command line parameters
      try {
        for (i=0 ; i<args.length ; i++) {
        
          if (args[i].equals("-h")) {
            if (i == args.length-1)
              throw new Exception();
            host = args[++i];
          } else if (args[i].equals("-e")) {
            if (i == args.length-1)
              throw new Exception();
            exp = args[++i];
          } else throw new Exception();
        } 
      } catch (Exception e) {
        System.err.println("Usage: JMidas [-h host] [-e experiment]");
        System.exit(1);
        }
      
      experiment = new CH.psi.midas.Experiment(host, exp, "JMidas");
      try {
		experiment.connect();
      } catch (UnknownExpException e) {
        JOptionPane.showMessageDialog(this, "Experiment "+experiment.getExperiment()+
                                            " not defined on host "+experiment.getHost(), 
                                            "JMIDAS" , 
                                            JOptionPane.ERROR_MESSAGE, 
                                            null);
		System.exit(1);
                                            
      } catch (Exception e) {
        JOptionPane.showMessageDialog(this, "Cannot connect to host "+experiment.getHost(), 
                                            "JMIDAS" , 
                                            JOptionPane.ERROR_MESSAGE, 
                                            null);
		System.exit(1);
      }
      
      // now connect all panels
      try {
        JPanelStatus1.connect(experiment);
        JPanelOdb1.connect(experiment);
        JPanelHistory1.connect(experiment);
      } catch (Exception e) {
        e.printStackTrace();                                            
        JOptionPane.showMessageDialog(this, "Cannot read data from ODB: "+e.getMessage(), 
                                            "JMIDAS" , 
                                            JOptionPane.ERROR_MESSAGE, 
                                            null);
        System.exit(1);                                   
      }
  
      // monitor run state changes
      try {
        runState = new OdbKey(experiment, "/Runinfo/State");
        runState.hotLink(this);
        
        // set inital button state
        update(runState);
      } catch (Exception e) { System.out.println(e); }
      
      // start bsh
      interpreter = new bsh.Interpreter(console);
      JPanelBsh.add(console);
	  Thread thread = new Thread(interpreter);
	  thread.start();
    
      interpreter.setVariable("jmidas", this);
      interpreter.setVariable("pstatus", JPanelStatus1);
      interpreter.setVariable("exp", experiment);
      interpreter.eval("import CH.psi.midas.*");
    }
    
    /**
     * Notifies this component that it has been added to a container
     * This method should be called by <code>Container.add</code>, and 
     * not by user code directly.
     * Overridden here to adjust the size of the frame if needed.
     * @see java.awt.Container#removeNotify
     */
	public void addNotify()
	{
		super.addNotify();
		
		if (frameSizeAdjusted)
			return;
		frameSizeAdjusted = true;
		
		// Adjust size of frame according to the insets, the menu & tool bars
        // and the preferred size of the status panel
		Dimension menu   = JMenuBar1.getPreferredSize();    
		Dimension status = JPanelStatus1.getPreferredSize();    
		Dimension tool   = JToolBar1.getPreferredSize();
		Dimension f = this.getPreferredSize();
		
		Insets insets = getInsets();
		setLocation(50, 50);
		setSize(insets.left + insets.right + status.width, 
		        insets.top + insets.bottom + menu.height + status.height + tool.height);
	}

	// Used by addNotify
	boolean frameSizeAdjusted = false;

    
	//{{DECLARE_CONTROLS
	javax.swing.JPanel JPanel2 = new javax.swing.JPanel();
	javax.swing.JToolBar JToolBar1 = new javax.swing.JToolBar();
	javax.swing.JButton buttonStart = new javax.swing.JButton();
	javax.swing.JButton buttonStop = new javax.swing.JButton();
	javax.swing.JButton buttonPause = new javax.swing.JButton();
	javax.swing.JPanel JPanel1 = new javax.swing.JPanel();
	javax.swing.JTabbedPane JTabbedPane1 = new javax.swing.JTabbedPane();
	JPanelStatus JPanelStatus1 = new JPanelStatus();
	JPanelOdb JPanelOdb1 = new JPanelOdb();
	JPanelHistory JPanelHistory1 = new JPanelHistory();
	javax.swing.JPanel JPanelBsh = new javax.swing.JPanel();
	javax.swing.JMenuBar JMenuBar1 = new javax.swing.JMenuBar();
	javax.swing.JMenu fileMenu = new javax.swing.JMenu();
	javax.swing.JMenuItem startItem = new javax.swing.JMenuItem();
	javax.swing.JMenuItem stopItem = new javax.swing.JMenuItem();
	javax.swing.JMenuItem pauseItem = new javax.swing.JMenuItem();
	javax.swing.JMenuItem exitItem = new javax.swing.JMenuItem();
	javax.swing.JMenu helpMenu = new javax.swing.JMenu();
	javax.swing.JMenuItem aboutItem = new javax.swing.JMenuItem();
	com.symantec.itools.javax.swing.icons.ImageIcon iconStart = new com.symantec.itools.javax.swing.icons.ImageIcon();
	com.symantec.itools.javax.swing.icons.ImageIcon iconStop = new com.symantec.itools.javax.swing.icons.ImageIcon();
	com.symantec.itools.javax.swing.icons.ImageIcon iconPause = new com.symantec.itools.javax.swing.icons.ImageIcon();
	//}}

    // bsh console
    bsh.util.JConsole console = new bsh.util.JConsole();
    bsh.Interpreter interpreter;

    // ODB keys
    OdbKey runState;
    
	//{{DECLARE_MENUS
	//}}

	void exitApplication()
	{
		try {
	    	// Show a confirmation dialog
	    	int reply = JOptionPane.showConfirmDialog(this, 
	    	                                          "Do you really want to exit?", 
	    	                                          "JMIDAS" , 
	    	                                          JOptionPane.YES_NO_OPTION, 
	    	                                          JOptionPane.QUESTION_MESSAGE);
			// If the confirmation was affirmative, handle exiting.
			if (reply == JOptionPane.YES_OPTION)
			{
			    experiment.disconnect();
		    	this.setVisible(false);    // hide the Frame
		    	this.dispose();            // free the system resources
		    	System.exit(0);            // close the application
			}
		} catch (Exception e) {
		}
	}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == JMidas.this)
                jmidas_windowClosing(event);
		}
	}

    void jmidas_windowClosing(java.awt.event.WindowEvent event)
    {
        try {
            this.exitApplication();
        } catch (Exception e) {}
    }

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == startItem)
				buttonStart_actionPerformed(event);
			else if (object == stopItem)
				buttonStop_actionPerformed(event);
			else if (object == pauseItem)
				buttonPause_actionPerformed(event);
			else if (object == exitItem)
				exitItem_actionPerformed(event);
			else if (object == aboutItem)
				aboutItem_actionPerformed(event);
			else if (object == buttonStart)
				buttonStart_actionPerformed(event);
			else if (object == buttonStop)
				buttonStop_actionPerformed(event);
			else if (object == buttonPause)
				buttonPause_actionPerformed(event);
			
		}
	}

	void exitItem_actionPerformed(java.awt.event.ActionEvent event)
	{
      exitItem_actionPerformed_Interaction1(event);
	}

	void exitItem_actionPerformed_Interaction1(java.awt.event.ActionEvent event) {
		try {
			this.exitApplication();
		} catch (Exception e) {
		}
	}

	void aboutItem_actionPerformed(java.awt.event.ActionEvent event)
	{
      JOptionPane.showMessageDialog(this, "MIDAS Version "+experiment.MIDAS_VERSION, 
                                          "JMIDAS" , 
                                          JOptionPane.INFORMATION_MESSAGE, 
                                          null);
	}

	void buttonStart_actionPerformed(java.awt.event.ActionEvent event)
	{
      experiment.startDialog(this);
	}

	void buttonStop_actionPerformed(java.awt.event.ActionEvent event)
	{
      experiment.stopDialog(this);
	}

	void buttonPause_actionPerformed(java.awt.event.ActionEvent event)
	{
	  if (runState.toString().equals("2"))
	    experiment.resume();
	  else
	    experiment.pause();
	}
	
	public void update(OdbKey key) {
	  if (runState == key) {
	    if (key.toString().equals("1")) {
          buttonStart.setEnabled(true);	        
          buttonStop.setEnabled(false);	        
          buttonPause.setEnabled(false);	        
	    } else if (key.toString().equals("2")) {
          buttonStart.setEnabled(false);	        
          buttonStop.setEnabled(true);	        
          buttonPause.setEnabled(true);	        
	    } else if (key.toString().equals("3")) {
          buttonStart.setEnabled(false);	        
          buttonStop.setEnabled(true);	        
          buttonPause.setEnabled(true);	        
	    }
	  }
	}
}
